// INDEPENDENT TEST

#include <MemberVariableSpecification_serialization.hh>
#include <MObject_serialization.hh>


// Variable Specification

namespace boost {
namespace serialization {

template<class Archive>
void save(Archive & ar, const MemberVariableSpecification & m, const unsigned int version)
{
	unsigned int tmp;
	
	ar & make_nvp("MObject",boost::serialization::base_object<MObject>(m));
	
	tmp = 1001;
	ar & make_nvp("link_id",tmp);
	ar & BOOST_SERIALIZATION_NVP(m.variable_link_id);
	
	tmp = 100;
	ar & make_nvp("link_id",tmp);
}

template<class Archive>
void load(Archive & ar, MemberVariableSpecification & m, const unsigned int version)
{
	unsigned int tmp;
	
	ar & make_nvp("MObject",boost::serialization::base_object<MObject>(m));
	
	while (true)
	{
		ar & make_nvp("link_id",tmp);
	
		switch (tmp)	
		{
			case 100:
			{
				return;
			}; break;
			
			case 1001:
			{
				ar & BOOST_SERIALIZATION_NVP(m.variable_link_id);
			}; break;
			
			// Other cases:
			// They will be treated with the correct type, however no data will be saved into the object
			// +++ Later an improvement can get the type from the archive and just throw that into the void
		}
	}
}

}
}

BOOST_CLASS_EXPORT(MemberVariableSpecification)

const char * MemberVariableSpecification::get_key()const
{
	const boost::serialization::extended_type_info *eti = 
	boost::serialization::type_info_implementation<MemberVariableSpecification>::type::get_instance();
	
	//error_stream << "I was asked to produce a Key: MVS:" << eti->get_key() <<  ": " << name << ".\n";
	//error_stream.flush();
	
	return eti->get_key();      
}
